interface ColaConPrioridad {

    static int PRIORIDAD_MAXIMA = 1;

    /**
     * Insertar el objeto indicado en la posicin adecuada de la cola 
     * segn su prioridad.
     * La prioridad se indica mediante un nmero natural (>= 0).
     * Cuanto mayor es dicho nmero, menor es la prioridad del elemento 
     * asociado. El valor 1 corresponde a los elementos con prioridad mxima.
     */
    void insertar(int prioridad, Object info);

    /**
     * Extrae el objeto con mayor prioridad de la cola 
     * (es decir, aqul cuya prioridad tenga valor mnimo)
     * En el caso de que varios elementos tengan la misma prioridad, 
     * se devuelve el primero que se introdujo (FIFO).
     * Si la cola est vaca, devuelve null.
     */
    Object extraer();

    /**
     * Devuelve el nmero de elementos de la cola
     */
    int tamao();

    /**
     * Indica si la cola est vaca.
     */
    boolean isVacio();

    
    /**
     * Imprime los trabajos en cola.
     */
    void print();
}
